#include <QGuiApplication>
#include <Qt3DQuickExtras/Qt3DQuickWindow>
#include <Qt3DQuick/QQmlAspectEngine>
#include <QQmlEngine>
#include <QQmlContext>

#include "customaspect.h"
#include "fpsmonitor.h"

int main(int argc, char **argv)
{
    QGuiApplication app(argc, argv);
    Qt3DExtras::Quick::Qt3DQuickWindow view;

    view.engine()->aspectEngine()->registerAspect(new CustomAspect);

    qmlRegisterType<FpsMonitor>("CustomModule", 1, 0, "FpsMonitor");

    auto rootContext = view.engine()->qmlEngine()->rootContext();
    rootContext->setContextProperty(QStringLiteral("ASSETS_PATH"),
                                    QUrl::fromLocalFile(QStringLiteral(ASSETS)));
    rootContext->setContextProperty("_window", &view);
    view.setSource(QUrl("qrc:/main.qml"));
    view.show();
    return app.exec();
}
