import Qt3D.Core 2.0
import Qt3D.Render 2.0
import Qt3D.Input 2.0
import Qt3D.Extras 2.0
import CustomModule 1.0

DefaultSceneEntity {
    id: scene

    Entity {
        id: donut

        components: [
            TorusMesh {
                radius: 3
                minorRadius: 1
                rings: 60
                slices: 30
            },
            NormalDiffuseSpecularMapMaterial {
                ambient: Qt.rgba(0.5, 0.5, 0.5, 1)
                shininess: 50
                diffuse: TextureLoader { source: ASSETS_PATH + "textures/donuts/drizzle/diffuse.png" }
                normal: TextureLoader { source: ASSETS_PATH + "textures/donuts/drizzle/normal.png" }
                specular: TextureLoader { source: ASSETS_PATH + "textures/donuts/drizzle/specular.png" }
            },
            Transform {
                rotationX: 90
            }
        ]
    }

    Entity {
        components: [
            FpsMonitor {
                rollingMeanFrameCount: 20
                onFramesPerSecondChanged: {
                    var fpsString = parseFloat(Math.round(framesPerSecond * 100) / 100).toFixed(2);
                    _window.title = "CustomAspect: FPS = " + fpsString
                            + " (" + rollingMeanFrameCount + " frame average)"
                }
            }
        ]
    }

    camera: Camera {
        position: Qt.vector3d(10, 10, 10)
        viewCenter: Qt.vector3d(0, 0, 0)
    }

    OrbitCameraController {
        camera: scene.camera
        linearSpeed: 50
        lookSpeed: 180
    }
}
